<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (28)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="polyfills-and-transpilers">Polyfills and transpilers</h1>
    <p>
      The JavaScript language steadily evolves. New proposals to the language
      appear regularly, they are analyzed and, if considered worthy, are
      appended to the list at
      <a href="https://tc39.github.io/ecma262/" class="uri"
        >https://tc39.github.io/ecma262/</a
      >
      and then progress to the
      <a
        href="http://www.ecma-international.org/publications/standards/Ecma-262.htm"
        >specification</a
      >.
    </p>
    <p>
      Teams behind JavaScript engines have their own ideas about what to
      implement first. They may decide to implement proposals that are in draft
      and postpone things that are already in the spec, because they are less
      interesting or just harder to do.
    </p>
    <p>
      So it’s quite common for an engine to implement only the part of the
      standard.
    </p>
    <p>
      A good page to see the current state of support for language features is
      <a href="https://kangax.github.io/compat-table/es6/" class="uri"
        >https://kangax.github.io/compat-table/es6/</a
      >
      (it’s big, we have a lot to study yet).
    </p>
    <p>
      As programmers, we’d like to use most recent features. The more good stuff
      - the better!
    </p>
    <p>
      On the other hand, how to make our modern code work on older engines that
      don’t understand recent features yet?
    </p>
    <p>There are two tools for that:</p>
    <ol type="1">
      <li>Transpilers.</li>
      <li>Polyfills.</li>
    </ol>
    <p>
      Here, in this chapter, our purpose is to get the gist of how they work,
      and their place in web development.
    </p>
    <h2 id="transpilers">Transpilers</h2>
    <p>
      A
      <a href="https://en.wikipedia.org/wiki/Source-to-source_compiler"
        >transpiler</a
      >
      is a special piece of software that can parse (“read and understand”)
      modern code, and rewrite it using older syntax constructs, so that the
      result would be the same.
    </p>
    <p>
      E.g. JavaScript before year 2020 didn’t have the “nullish coalescing
      operator” <code>??</code>. So, if a visitor uses an outdated browser, it
      may fail to understand the code like <code>height = height ?? 100</code>.
    </p>
    <p>
      A transpiler would analyze our code and rewrite
      <code>height ?? 100</code> into
      <code
        >(height !== undefined &amp;&amp; height !== null) ? height : 100</code
      >.
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="co">// before running the transpiler</span></a>
<a class="sourceLine" id="cb1-2" title="2">height <span class="op">=</span> height <span class="op">??</span> <span class="dv">100</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">// after running the transpiler</span></a>
<a class="sourceLine" id="cb1-5" title="5">height <span class="op">=</span> height <span class="op">!==</span> <span class="kw">undefined</span> <span class="op">&amp;&amp;</span> height <span class="op">!==</span> <span class="kw">null</span> <span class="op">?</span> height : <span class="dv">100</span><span class="op">;</span></a></code></pre>
    </div>
    <p>Now the rewritten code is suitable for older JavaScript engines.</p>
    <p>
      Usually, a developer runs the transpiler on their own computer, and then
      deploys the transpiled code to the server.
    </p>
    <p>
      Speaking of names, <a href="https://babeljs.io">Babel</a> is one of the
      most prominent transpilers out there.
    </p>
    <p>
      Modern project build systems, such as
      <a href="http://webpack.github.io/">webpack</a>, provide means to run
      transpiler automatically on every code change, so it’s very easy to
      integrate into development process.
    </p>
    <h2 id="polyfills">Polyfills</h2>
    <p>
      New language features may include not only syntax constructs and
      operators, but also built-in functions.
    </p>
    <p>
      For example, <code>Math.trunc(n)</code> is a function that “cuts off” the
      decimal part of a number, e.g <code>Math.trunc(1.23)</code> returns
      <code>1</code>.
    </p>
    <p>
      In some (very outdated) JavaScript engines, there’s no
      <code>Math.trunc</code>, so such code will fail.
    </p>
    <p>
      As we’re talking about new functions, not syntax changes, there’s no need
      to transpile anything here. We just need to declare the missing function.
    </p>
    <p>
      A script that updates/adds new functions is called “polyfill”. It “fills
      in” the gap and adds missing implementations.
    </p>
    <p>
      For this particular case, the polyfill for <code>Math.trunc</code> is a
      script that implements it, like this:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="cf">if</span> (<span class="op">!</span><span class="va">Math</span>.<span class="at">trunc</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="co">// if no such function</span></a>
<a class="sourceLine" id="cb2-3" title="3">  <span class="co">// implement it</span></a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="va">Math</span>.<span class="at">trunc</span> <span class="op">=</span> <span class="kw">function</span> (number) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-5" title="5">    <span class="co">// Math.ceil and Math.floor exist even in ancient JavaScript engines</span></a>
<a class="sourceLine" id="cb2-6" title="6">    <span class="co">// they are covered later in the tutorial</span></a>
<a class="sourceLine" id="cb2-7" title="7">    <span class="cf">return</span> number <span class="op">&lt;</span> <span class="dv">0</span> <span class="op">?</span> <span class="va">Math</span>.<span class="at">ceil</span>(number) : <span class="va">Math</span>.<span class="at">floor</span>(number)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-8" title="8">  <span class="op">};</span></a>
<a class="sourceLine" id="cb2-9" title="9"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      JavaScript is a highly dynamic language, scripts may add/modify any
      functions, even including built-in ones.
    </p>
    <p>Two interesting libraries of polyfills are:</p>
    <ul>
      <li>
        <a href="https://github.com/zloirock/core-js">core js</a> that supports
        a lot, allows to include only needed features.
      </li>
      <li>
        <a href="http://polyfill.io">polyfill.io</a> service that provides a
        script with polyfills, depending on the features and user’s browser.
      </li>
    </ul>
    <h2 id="summary">Summary</h2>
    <p>
      In this chapter we’d like to motivate you to study modern and even
      “bleeding-edge” language features, even if they aren’t yet well-supported
      by JavaScript engines.
    </p>
    <p>
      Just don’t forget to use transpiler (if using modern syntax or operators)
      and polyfills (to add functions that may be missing). And they’ll ensure
      that the code works.
    </p>
    <p>
      For example, later when you’re familiar with JavaScript, you can setup a
      code build system based on
      <a href="http://webpack.github.io/">webpack</a> with
      <a href="https://github.com/babel/babel-loader">babel-loader</a> plugin.
    </p>
    <p>
      Good resources that show the current state of support for various
      features:
    </p>
    <ul>
      <li>
        <a href="https://kangax.github.io/compat-table/es6/" class="uri"
          >https://kangax.github.io/compat-table/es6/</a
        >
        - for pure JavaScript.
      </li>
      <li>
        <a href="https://caniuse.com/" class="uri">https://caniuse.com/</a> -
        for browser-related functions.
      </li>
    </ul>
    <p>
      P.S. Google Chrome is usually the most up-to-date with language features,
      try it if a tutorial demo fails. Most tutorial demos work with any modern
      browser though.
    </p>
  </body>
</html>
